# RELEASES

This document describes how Kruise handles versioning, releases new versions and communicates about them.

Kruise uses semantic versioning so that their users can reliably upgrade according to their needs.

## Release Cycle

Kruise is using a release schedule of 2 to 3 months and uses [GitHub milestones](https://github.com/openkruise/kruise/milestones) to provide an indication of when the next release is planned.
It can, however, happen that releases get delayed which will be reflected on the milestone.

## Release Process

You can learn about our release process [here](./RELEASE-PROCESS.md).

## Keeping Track Of Changes

We provide a changelog that includes every change per version must be available as part of the repo, for example, here is the [changelog for Kruise](./CHANGELOG.md).

Next to that, every closed issue and PR should be added to a GitHub Milestone that provides an overview of everything that will be included and provide an indication of what the current intended release date is.
However, the release date is subject to change and only provides an indication.

Lastly, every new release will come with a GitHub Release which provides the exact changelog for that release.

## Get Notified For New Releases

If you want to be notified of new releases, we recommend [watching](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/setting-up-notifications/configuring-notifications#configuring-your-watch-settings-for-an-individual-repository) our [openkruise/kruise repository](https://github.com/openkruise/kruise) on GitHub and ensure you are subscribing for releases.

Next to that, you can join the conversation for every new release on GitHub Discussions.

## Support

- [User Documentation](https://openkruise.io/docs/)
- Community
  - [GitHub Discussions](https://github.com/openkruise/kruise/discussions/new)
  - [Channel #openkruise in Kubernetes Slack](https://kubernetes.slack.com/channels/openkruise) ([registration](http://slack.k8s.io/))
  - DingTalk：Search GroupID 23330762 (Chinese)
